using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid;

namespace WindowsApplication1
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		public DataTable m_Table;
		public enum MyEnum
		{
			ENUM_1,
			ENUM_2,
			ENUM_3
		};
		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			m_Table = new DataTable();
			m_Table.Columns.Add(new DataColumn("stringtype",typeof(string)));
			m_Table.Columns.Add(new DataColumn("enumtype",typeof(MyEnum)));
			gridDataBoundGrid1.DataSource = m_Table;

			this.gridDataBoundGrid1.Model.CellModels.Add("EnumType", new EnumCellModel(this.gridDataBoundGrid1.Model));
			this.gridDataBoundGrid1.Binder.InternalColumns["enumtype"].StyleInfo.CellType = "EnumType";
			this.gridDataBoundGrid1.Binder.InternalColumns["enumtype"].StyleInfo.CellValueType = typeof(MyEnum);
		
			DataRow row = m_Table.NewRow();
			row["stringtype"] = "row1";
			row["enumtype"] = MyEnum.ENUM_2;
			m_Table.Rows.Add(row);

			 
		
			}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(32, 24);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(232, 208);
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.Click += new System.EventHandler(this.gridDataBoundGrid1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void gridDataBoundGrid1_Click(object sender, System.EventArgs e)
		{
		
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
		
		}
	}

	public class EnumCellModel : GridTextBoxCellModel
	{
		public EnumCellModel(GridModel grid)
			: base(grid)
		{

		}
	
		public override string GetFormattedText(GridStyleInfo style, object value, int textInfo)
		{
			if(value != null && value.ToString().Length > 0)
				return ((Form1.MyEnum)value).ToString();
			else
				return "";
		}
	}
}
